class Hash

  # Iterates through each pair and updates a the hash
  # in place. This is formally equivalent to #collate!
  # But does not use #collate to accomplish the task.
  # Hence #update_each is probably a bit faster.
  #
  #   # TODO
  #
  #--
  # Note that this may get some fine tuning as currently
  # it expects the block to return a "mini-hash" pair.
  #++
  def update_each  # :yield:
    dup.each_pair{ |k,v| update( yield(k,v) ); }
    self
  end

end


#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
=begin test

  require 'test/unit'

  class TCHash < Test::Unit::TestCase

    def test_update_each
      a = { :a => 1, :b => 2, :c => 3 }
      e = { :a => 2, :b => 3, :c => 4 }
      a.update_each{ |k,v| { k => v+1 } }
      assert_equal( e, a )
    end

  end

=end
